/*
 * CA-Visual Objects 2.8(2800) ASM custom compiler subsystem
 *
 *
 * Sabo(FdW)										09/02/99(10/17/2006)
 **********************************************************************/

#include <windows.h>
#include <malloc.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <io.h>

#include <cavoide.h>
#include <idemain.h>
#include <cavossys.h>
#include <ideeidmr.h>
#include <cavoadam.h>

#include "nasm4vo.h"

#pragma warning(disable : 4996)

extern "C" void pp_include_path (char *);

HINSTANCE	hInstance;

// The NASM code itself is not thread safe,
// so we don't have to be either
long		ridCur;
INT			iLineCorr;

#define ASM_CODE_PREFIX	"BITS 32\r\nGLOBAL __entrypoint42\r\nSECTION .text\r\n__entrypoint42:\r\n"
#define ASM_DATA_PREFIX	"BITS 32\r\nGLOBAL __entrypoint42\r\nSECTION .data\r\n__entrypoint42:\r\n"

extern "C" {

BOOL APIENTRY DllMain(HINSTANCE hMod, DWORD dwReason, LPVOID lpReserved)
{
	switch (dwReason)
	{

		case DLL_PROCESS_ATTACH:

			hInstance = hMod;
			return(TRUE);

		case DLL_THREAD_ATTACH:

			return(TRUE);


		case DLL_THREAD_DETACH:

			return(TRUE);


		case DLL_PROCESS_DETACH:

			return(TRUE);

	}

	return(FALSE);
}


BOOL CEXPORT REGISTER(LPSUBSYSDECL lpSubSys)
{
	lpSubSys->wNEntities = 1;
	*lpSubSys->achMenuName = 0;

	lpSubSys->entityDecl[0].uiEntityType = ETYPE_ASM;

	// Name will be ignored, since we are faking VO language entities
	strcpy((LPCHAR)lpSubSys->entityDecl[0].abSymbolName, "Asm");

	return(TRUE);
}


BOOL CEXPORT EDIT(HWND hParent, LPCREATEEDITBLOCK lpCEB, LPINSTALLBLOCK pIB)
{
	// Could be removed, is actually never called since the source code
	// editor is used for editing

	return(TRUE);
}


BOOL CEXPORT INIT(VOID)
{
	LPCHAR	p;
	CHAR	achModule[MAX_PATH];

	NasmInit();

	GetModuleFileName(NULL, achModule, sizeof(achModule));

	if(p = strrchr(achModule, '\\'))
	{
		*(p+1) = '\0';
		pp_include_path(achModule);
	}

	return(TRUE);
}


BOOL CEXPORT COMPOPT(RID rid, LPVOID lpOptions)
{
	return(TRUE);
}


BOOL CEXPORT COMPILE(RID rid, BOOL fCreateZombie, UINT uiDebug, LPLPBYTE pbErrors, LPUINT pcbErrors, LPUINT puiExpChng)
{
	RID			ridSrc, ridFixups;
	UINT		cbSrc, cbFixups;
	UINT		cb;
	CHAR		achFileName[MAX_PATH];
	BOOL		fCont;
	LPCHAR		lpchSrc, p;
	RETCODE		rc;

	ridCur = rid;

	// Clear implicants list
	rc = EntClearImpList(rid);
	ERRCHK(Error1);

	// Unfortunately we cannot mess around with the entity directly,
	// since necessary declarations are not in the SDK
	rc = EntQueryData(rid, DT_SOURCE, &ridSrc, &cbSrc, &ridFixups, &cbFixups);
	ERRCHK(Error1);

	// Get the source code
	lpchSrc = (LPCHAR)RecGet(ridSrc, cbSrc,0);
	ERRIF(!lpchSrc,Error1);

#ifdef _DEBUG //FdW//20061020//
	OutputDebugString("--Compile--\r\n");
	OutputDebugString(lpchSrc);
#endif

	// Simple handling for multi line prototypes
	p = lpchSrc;
	fCont = FALSE;
	iLineCorr = 0;
	while(*p)
	{
		if(*p == ';')
		{
			fCont = TRUE;
		}

		if(*p=='\r' || *p=='\n')
		{
			if(!fCont)
			{
				break;
			}

			iLineCorr++;

			if(p[1]=='\r' || p[1]=='\n')
			{
				p++;
			}

			fCont = FALSE;
		}
		p++;
	}

	if(*p)
	{
		HANDLE hf;

		GetTempPath(sizeof(achFileName), achFileName);
		GetTempFileName(achFileName, "von", 0, achFileName);
		hf = CreateFile(achFileName,
						GENERIC_WRITE,
						0,
						NULL,
						CREATE_ALWAYS,
						FILE_ATTRIBUTE_NORMAL,
						NULL);

		if(hf != INVALID_HANDLE_VALUE)
		{
			rc = EntQueryBlockType(rid, &cb);
				ERRCHK(Error1);

			if(cb == BL_GLOBAL)
			{
				WriteFile(hf, ASM_DATA_PREFIX, strlen(ASM_DATA_PREFIX), (LPDWORD)&cb, NULL);
			}
			else
			{
				WriteFile(hf, ASM_CODE_PREFIX, strlen(ASM_DATA_PREFIX), (LPDWORD)&cb, NULL);
			}

			WriteFile(hf, p, cbSrc - (p-lpchSrc) - 1, (LPDWORD)&cb, NULL);
			CloseHandle(hf);
			NasmMain(achFileName, (LONG)rid);	
			DeleteFile(achFileName);

			vo_get_error_info((char**)pbErrors, pcbErrors);
		}
	}

	return(TRUE);

Error1:
	return(FALSE);
}

/******************************************************************
**
** FdW//20061020// Rewritten to handle 'STAT[I[C]] ASM ...' and
**					'ASM STAT[I[C]] ...' corectly.
**
******************************************************************/
WORD CEXPORT ISDECL(LPSTR lpstrProt)
{
	LPSTR	lpstrFrst;
	LPSTR	lpstrTest;
	DWORD	lStatic;
	WORD	wRet;

#ifdef _DEBUG //FdW//20061020//
	OutputDebugString("--IsDecl--\r\n");
#endif
	wRet=FALSE;
	if(lpstrProt)
	{
#ifdef _DEBUG //FdW//20061020//
		OutputDebugString(lpstrProt);
		OutputDebugString("\r\n");
#endif
		lStatic=0;
		lpstrFrst=lpstrTest=lpstrProt+strspn(lpstrProt," \t");
		if(*lpstrTest=='s' || *lpstrTest=='S') {
			lpstrTest++;
			if(*lpstrTest=='t' || *lpstrTest=='T') {
				lpstrTest++;
				if (*lpstrTest=='a' || *lpstrTest=='A') {
					lpstrTest++;
					if (*lpstrTest=='t' || *lpstrTest=='T') {
						lpstrTest++;
						if(*lpstrTest==' ' || *lpstrTest=='\t') {
							lStatic=1;
						} else {
							if(*lpstrTest=='i' || *lpstrTest=='I') {
								lpstrTest++;
								if(*lpstrTest==' ' || *lpstrTest=='\t') {
									lStatic=1;
								} else {
									if(*lpstrTest=='c' || *lpstrTest=='C') {
										lpstrTest++;
										if(*lpstrTest==' ' || *lpstrTest=='\t') {
											lStatic=1;
										}
									}
								}
							}
						}
					}
				}
			}
		}
		if(lStatic) {
			lpstrFrst=lpstrTest+strspn(lpstrTest," \t");
		}
		lpstrTest=lpstrFrst;
		if(*lpstrTest=='a' || *lpstrTest=='A') {
			lpstrTest++;
			if(*lpstrTest=='s' || *lpstrTest=='S') {
				lpstrTest++;
				if (*lpstrTest=='m' || *lpstrTest=='M') {
					lpstrTest++;
					if (*lpstrTest==' ' || *lpstrTest=='\t') {
#ifdef _DEBUG //FdW//20061020//
						DWORD dwSaveAsm;
						dwSaveAsm=*(LPDWORD)lpstrFrst;
						*(LPDWORD)lpstrFrst=0x20202020;
						OutputDebugString(lpstrProt);
						OutputDebugString("\r\n");
						*(LPDWORD)lpstrFrst=dwSaveAsm;
#endif
						wRet=ETYPE_CAIN;
					}
				}
			}
		}
	}
	return(wRet);
/*
	CHAR	cSave;
	WORD	wRet;
	LPCHAR	p;

	wRet=FALSE
	lpstrProt += strspn(lpstrProt, " \t");
	p = lpstrProt + strcspn(lpstrProt, " \t");
	if(p != lpstrProt)
	{
		cSave = *p;
		*p = '\0';
		if(!stricmp(lpstrProt, "static"))
		{
			*p = cSave;
			lpstrProt = p + strspn(p, " \t");
			p = lpstrProt + strcspn(lpstrProt, " \t");
			cSave = *p;
			*p = '\0';
		}
		// Make ourselfes an extension to the system compiler, Requires CA-VO 2.5a
		wRet = !stricmp(lpstrProt, "asm") ? ETYPE_CAIN : 0;
		*p = cSave;
//		return(wRet);
	}
	return(wRet);
*/
}


WORD CEXPORT ISDECLEX(LPSTR lpstrProt, LPUINT lpuiRealType)
{
	WORD	wRet;

	*lpuiRealType = ETYPE_VOID;
	wRet = ISDECL(lpstrProt);
	if(wRet == ETYPE_CAIN)
	{
		*lpuiRealType = ETYPE_ASM;		
	}
	return(wRet);
}


/******************************************************************
**
** FdW//20061020// Rewritten to handle 'STAT[I[C]] ASM ...' and
**					'ASM STAT[I[C]] ...' corectly.
**
******************************************************************/
RETCODE CEXPORT PROT(RID rid, LPSTR lpstrProt, LPUINT lpuiExpChng, LPRID lpridConf)
{
	LPSTR	lpstrFrst;
	LPSTR	lpstrTest;
	DWORD	dwSaveAsm;
	DWORD	lStatic;
	RETCODE	rc;

#ifdef _DEBUG //FdW//20061020//
	OutputDebugString("--Prot--\r\n");
#endif
	rc = SUCCESS;
	if(lpstrProt)
	{
#ifdef _DEBUG //FdW//20061020//
		OutputDebugString(lpstrProt);
		OutputDebugString("\r\n");
#endif
		lStatic=0;
		lpstrFrst=lpstrTest=lpstrProt+strspn(lpstrProt," \t");
		if(*lpstrTest=='s' || *lpstrTest=='S') {
			lpstrTest++;
			if(*lpstrTest=='t' || *lpstrTest=='T') {
				lpstrTest++;
				if (*lpstrTest=='a' || *lpstrTest=='A') {
					lpstrTest++;
					if (*lpstrTest=='t' || *lpstrTest=='T') {
						lpstrTest++;
						if(*lpstrTest==' ' || *lpstrTest=='\t') {
							lStatic=1;
						} else {
							if(*lpstrTest=='i' || *lpstrTest=='I') {
								lpstrTest++;
								if(*lpstrTest==' ' || *lpstrTest=='\t') {
									lStatic=1;
								} else {
									if(*lpstrTest=='c' || *lpstrTest=='C') {
										lpstrTest++;
										if(*lpstrTest==' ' || *lpstrTest=='\t') {
											lStatic=1;
										}
									}
								}
							}
						}
					}
				}
			}
		}
		if(lStatic) {
			lpstrFrst=lpstrTest+strspn(lpstrTest," \t");
		}
		lpstrTest=lpstrFrst;
		if(*lpstrTest=='a' || *lpstrTest=='A') {
			lpstrTest++;
			if(*lpstrTest=='s' || *lpstrTest=='S') {
				lpstrTest++;
				if (*lpstrTest=='m' || *lpstrTest=='M') {
					lpstrTest++;
					if (*lpstrTest==' ' || *lpstrTest=='\t') {
						dwSaveAsm=*(LPDWORD)lpstrFrst;
						*(LPDWORD)lpstrFrst=0x20202020;
#ifdef _DEBUG //FdW//20061020//
						OutputDebugString(lpstrProt);
						OutputDebugString("\r\n");
#endif
						rc=EntProt(rid,lpstrProt,(LPINT)lpuiExpChng,lpridConf);
						*(LPDWORD)lpstrFrst=dwSaveAsm;
					}
				}
			}
		}
	}
	return(rc);
/*
	DWORD	dwSaveAsm;
	CHAR	cSave;
	RETCODE	rc;
	LPCHAR	p;

	lpstrProt += strspn(lpstrProt, " \t");
	p = lpstrProt + strcspn(lpstrProt, " \t");
	if(p != lpstrProt)
	{
		lpstrFirst = lpstrProt;
		cSave = *p;
		*p = '\0';
		if(!stricmp(lpstrProt, "static"))
		{
			*p = cSave;
			lpstrProt = p + strspn(p, " \t");
			p = lpstrProt + strcspn(lpstrProt, " \t");
			cSave = *p;
			*p = '\0';
		}
		if(!stricmp(lpstrProt, "asm"))
		{
			*p = cSave;
			dwSave = *(LPDWORD)lpstrProt;
			*(LPDWORD)lpstrProt = 0x20202020;
//			rc = EntProt(rid, lpstrProt, (LPINT)lpuiExpChng, lpridConf); //FdW//
#ifdef _DEBUG //FdW//20061020//
			OutputDebugString(lpstrFirst);
#endif
			rc = EntProt(rid, lpstrFirst, (LPINT)lpuiExpChng, lpridConf); //FdW//
			*(LPDWORD)lpstrProt = dwSave;
		} else {
			*p = cSave;
		}
	}
	return(rc);
*/
}
	
BOOL CEXPORT EXIT(VOID)
{
	return TRUE;
}

}	// extern "C"

/*
** That's all folks!!!
 */